/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Imagem;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderImagem;

@Controller("busquedaImagemController")
@Scope("prototype")
public class BusquedaImagemController extends MyGenericForwardComposer {

	@Autowired
	private transient PagedListWrapper<Imagem> plwImagem;
	private MyListbox imagemList;
	private Paging pagingImagem;
	private Textbox txtNome;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		imagemList.setItemRenderer(new RenderImagem());
		imagemList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				Imagem c = (Imagem) imagemList.getSelected();
				verImagem(c);
			}
		});

		refreshLista();

		txtNome.focus();
	}

	private void verImagem(Imagem imagem) {
		if (imagem == null) {
			return;
		}

		Map args = new HashMap();
		args.put("busquedaImagemController", this);
		args.put("imagem", imagem);
		args.put("imagemList", imagemList);

		openWindow("/gui/catalogos/editarImagem.zul",
				Labels.getLabel("editarImagemController.window.title"), args, MODAL);
	}

	public void refreshLista() {
		HibernateSearchObject<Imagem> imagemBusqueda = new HibernateSearchObject<Imagem>(Imagem.class,
				pagingImagem.getPageSize());

		imagemBusqueda.addFilterLike("nombImagem",
				"%" + txtNome.getText().trim().concat("%"));

		imagemBusqueda.addSortAsc("nombImagem");
		imagemBusqueda.addFilterEqual("activo", Boolean.TRUE);

		plwImagem.init(imagemBusqueda, imagemList, pagingImagem);

		if (imagemList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaMarcaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verImagem(new Imagem());
	}

	public Textbox getTxtNome() {
		return txtNome;
	}

	public void setTxtNome(Textbox txtNome) {
		this.txtNome = txtNome;
	}

	public PagedListWrapper<Imagem> getPlwImagem() {
		return plwImagem;
	}

	public void setPlwImagem(PagedListWrapper<Imagem> plwImagem) {
		this.plwImagem = plwImagem;
	}

	public MyListbox getImagemList() {
		return imagemList;
	}

	public void setImagemList(MyListbox imagemList) {
		this.imagemList = imagemList;
	}

	public Paging getPagingImagem() {
		return pagingImagem;
	}

	public void setPagingImagem(Paging pagingImagem) {
		this.pagingImagem = pagingImagem;
	}

}
